--- before.txt	2019-07-17 09:06:49.608245000 +0900
+++ after.txt	2019-07-17 09:07:45.937245900 +0900
@@ -963,7 +963,7 @@
 font.c:3277: Test failed: gm1=46,51,1,51,48,0 gm2=57,51,-5,51,49,0
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
-font.c:3277: Test failed: gm1=47,49,0,49,49,0 gm2=53,49,1,49,46,0
+font.c:3277: Test failed: gm1=47,49,1,49,50,0 gm2=55,49,1,49,48,0
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 font.c:3277: Test failed: gm1=47,49,1,49,50,0 gm2=55,49,1,49,48,0
@@ -1762,22 +1762,6 @@
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
-(win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
-(win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
-(win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
-(win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
-(win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
-(win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
-(win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
-(win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
-(win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
-(win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
-(win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
-(win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
-(win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
-(win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
-(win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
-(win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 font.c:3277: Test failed: gm1=48,51,1,51,50,0 gm2=58,51,-5,51,50,0
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
@@ -1810,6 +1794,7 @@
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
+font.c:3277: Test failed: gm1=30,51,1,51,32,0 gm2=42,51,-3,51,33,0
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 font.c:3277: Test failed: gm1=30,51,1,51,32,0 gm2=42,51,-3,51,33,0
@@ -1850,6 +1835,7 @@
 font.c:3277: Test failed: gm1=60,53,0,53,60,0 gm2=72,53,-7,53,57,0
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
+font.c:3277: Test failed: gm1=44,51,2,51,48,0 gm2=53,51,-5,51,46,0
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 font.c:3277: Test failed: gm1=44,51,2,51,48,0 gm2=53,51,-5,51,46,0
@@ -1870,7 +1856,6 @@
 font.c:3277: Test failed: gm1=44,51,2,51,48,0 gm2=53,51,-5,51,46,0
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
-font.c:3277: Test failed: gm1=51,52,1,52,53,0 gm2=62,52,-6,52,52,0
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 font.c:3277: Test failed: gm1=51,52,1,52,53,0 gm2=62,52,-6,52,52,0
@@ -2089,10 +2074,8 @@
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 font.c:3277: Test failed: gm1=50,48,1,48,52,0 gm2=66,48,-5,48,57,0
-font.c:3951: Test failed: W: tmLastChar for Source Sans Pro ExtraLight got ffff expected feff
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
-font.c:3277: Test failed: gm1=36,45,1,45,38,0 gm2=51,45,-6,45,41,0
 font.c:3951: Test failed: W: tmLastChar for Source Sans Pro ExtraLight got ffff expected feff
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
@@ -2115,10 +2098,8 @@
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 font.c:3277: Test failed: gm1=36,45,1,45,38,0 gm2=51,45,-6,45,41,0
-font.c:3951: Test failed: W: tmLastChar for Source Sans Pro Light got ffff expected feff
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
-font.c:3277: Test failed: gm1=37,46,1,46,39,0 gm2=52,46,-6,46,42,0
 font.c:3951: Test failed: W: tmLastChar for Source Sans Pro Light got ffff expected feff
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
@@ -2141,8 +2122,10 @@
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 font.c:3277: Test failed: gm1=37,46,1,46,39,0 gm2=52,46,-6,46,42,0
+font.c:3951: Test failed: W: tmLastChar for Source Sans Pro Semibold got ffff expected feff
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
+font.c:3277: Test failed: gm1=45,47,1,47,47,0 gm2=60,47,-5,47,50,0
 font.c:3951: Test failed: W: tmLastChar for Source Sans Pro Semibold got ffff expected feff
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
@@ -2345,7 +2328,7 @@
 font.c:3277: Test failed: gm1=48,51,1,51,50,0 gm2=58,51,-5,51,50,0
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
-font.c:3277: Test failed: gm1=47,49,1,49,50,0 gm2=55,49,1,49,48,0
+font.c:3277: Test failed: gm1=47,49,0,49,49,0 gm2=53,49,1,49,46,0
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 font.c:3277: Test failed: gm1=47,49,1,49,50,0 gm2=55,49,1,49,48,0
@@ -2381,13 +2364,13 @@
 font.c:3277: Test failed: gm1=44,49,2,49,48,0 gm2=54,49,1,49,47,0
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
-font.c:3277: Test failed: gm1=50,50,1,50,51,0 gm2=56,49,1,49,48,0
+font.c:3277: Test failed: gm1=44,49,2,49,48,0 gm2=54,49,1,49,47,0
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 font.c:3277: Test failed: gm1=50,50,1,50,51,0 gm2=56,49,1,49,48,0
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
-font.c:3277: Test failed: gm1=50,50,1,50,51,0 gm2=56,49,1,49,48,0
+font.c:3277: Test failed: gm1=44,49,2,49,48,0 gm2=54,49,1,49,47,0
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 (win32ss/gdi/ntgdi/font.c:304) FontGetObject font not initialized!
 font.c:3277: Test failed: gm1=50,50,1,50,51,0 gm2=56,49,1,49,48,0
@@ -2712,5 +2695,5 @@
 font.c:5882: Test failed: AddFontResourceEx() error 2
 font.c:5891: Test failed: RemoveFontResourceEx() error -559038737
 
-font: 38902 tests executed (0 marked as todo, 1570 failures), 62 skipped.
-Test font completed in 19.93 seconds.
+font: 38470 tests executed (0 marked as todo, 1569 failures), 62 skipped.
+Test font completed in 19.85 seconds.